/* NBD client library in userspace
 * WARNING: THIS FILE IS GENERATED FROM
 * generator/generator
 * ANY CHANGES YOU MAKE TO THIS FILE WILL BE LOST.
 *
 * Copyright (C) 2013-2019 Red Hat Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

#include <config.h>

#include <stdio.h>
#include <stdlib.h>

#include <pthread.h>

#include "libnbd.h"
#include "internal.h"

int
nbd_set_debug (struct nbd_handle *h, bool debug)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_set_debug");
  ret = nbd_unlocked_set_debug (h, debug);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_get_debug (struct nbd_handle *h)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_get_debug");
  ret = nbd_unlocked_get_debug (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_set_debug_callback (struct nbd_handle *h, void *data, void (*debug_fn) (void *data, const char *context, const char *msg))
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_set_debug_callback");
  ret = nbd_unlocked_set_debug_callback (h, data, debug_fn);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_set_export_name (struct nbd_handle *h, const char *export_name)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_set_export_name");
  ret = nbd_unlocked_set_export_name (h, export_name);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

char *
nbd_get_export_name (struct nbd_handle *h)
{
  char *ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_get_export_name");
  ret = nbd_unlocked_get_export_name (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_set_tls (struct nbd_handle *h, int tls)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_set_tls");
  ret = nbd_unlocked_set_tls (h, tls);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_get_tls (struct nbd_handle *h)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_get_tls");
  ret = nbd_unlocked_get_tls (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_set_tls_certificates (struct nbd_handle *h, const char *dir)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_set_tls_certificates");
  ret = nbd_unlocked_set_tls_certificates (h, dir);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_set_tls_verify_peer (struct nbd_handle *h, bool verify)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_set_tls_verify_peer");
  ret = nbd_unlocked_set_tls_verify_peer (h, verify);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_get_tls_verify_peer (struct nbd_handle *h)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_get_tls_verify_peer");
  ret = nbd_unlocked_get_tls_verify_peer (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_set_tls_username (struct nbd_handle *h, const char *username)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_set_tls_username");
  ret = nbd_unlocked_set_tls_username (h, username);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

char *
nbd_get_tls_username (struct nbd_handle *h)
{
  char *ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_get_tls_username");
  ret = nbd_unlocked_get_tls_username (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_set_tls_psk_file (struct nbd_handle *h, const char *filename)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_set_tls_psk_file");
  ret = nbd_unlocked_set_tls_psk_file (h, filename);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_add_meta_context (struct nbd_handle *h, const char *name)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_add_meta_context");
  ret = nbd_unlocked_add_meta_context (h, name);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_connect_uri (struct nbd_handle *h, const char *uri)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_connect_uri");
  ret = nbd_unlocked_connect_uri (h, uri);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_connect_unix (struct nbd_handle *h, const char *unixsocket)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_connect_unix");
  ret = nbd_unlocked_connect_unix (h, unixsocket);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_connect_tcp (struct nbd_handle *h, const char *hostname, const char *port)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_connect_tcp");
  ret = nbd_unlocked_connect_tcp (h, hostname, port);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_connect_command (struct nbd_handle *h, char **argv)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_connect_command");
  ret = nbd_unlocked_connect_command (h, argv);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_read_only (struct nbd_handle *h)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_read_only");
  ret = nbd_unlocked_read_only (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_can_flush (struct nbd_handle *h)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_can_flush");
  ret = nbd_unlocked_can_flush (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_can_fua (struct nbd_handle *h)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_can_fua");
  ret = nbd_unlocked_can_fua (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_is_rotational (struct nbd_handle *h)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_is_rotational");
  ret = nbd_unlocked_is_rotational (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_can_trim (struct nbd_handle *h)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_can_trim");
  ret = nbd_unlocked_can_trim (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_can_zero (struct nbd_handle *h)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_can_zero");
  ret = nbd_unlocked_can_zero (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_can_multi_conn (struct nbd_handle *h)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_can_multi_conn");
  ret = nbd_unlocked_can_multi_conn (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_can_cache (struct nbd_handle *h)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_can_cache");
  ret = nbd_unlocked_can_cache (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_can_meta_context (struct nbd_handle *h, const char *metacontext)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_can_meta_context");
  ret = nbd_unlocked_can_meta_context (h, metacontext);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int64_t
nbd_get_size (struct nbd_handle *h)
{
  int64_t ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_get_size");
  ret = nbd_unlocked_get_size (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_pread (struct nbd_handle *h, void *buf, size_t count, uint64_t offset)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_pread");
  ret = nbd_unlocked_pread (h, buf, count, offset);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_pwrite (struct nbd_handle *h, const void *buf, size_t count, uint64_t offset, uint32_t flags)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_pwrite");
  ret = nbd_unlocked_pwrite (h, buf, count, offset, flags);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_shutdown (struct nbd_handle *h)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_shutdown");
  ret = nbd_unlocked_shutdown (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_flush (struct nbd_handle *h)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_flush");
  ret = nbd_unlocked_flush (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_trim (struct nbd_handle *h, uint64_t count, uint64_t offset, uint32_t flags)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_trim");
  ret = nbd_unlocked_trim (h, count, offset, flags);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_cache (struct nbd_handle *h, uint64_t count, uint64_t offset)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_cache");
  ret = nbd_unlocked_cache (h, count, offset);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_zero (struct nbd_handle *h, uint64_t count, uint64_t offset, uint32_t flags)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_zero");
  ret = nbd_unlocked_zero (h, count, offset, flags);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_block_status (struct nbd_handle *h, uint64_t count, uint64_t offset, uint32_t flags, void *data, void (*extent) (void *data, const char *metacontext, uint64_t offset, uint32_t *entries, size_t nr_entries))
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_block_status");
  ret = nbd_unlocked_block_status (h, count, offset, flags, data, extent);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_poll (struct nbd_handle *h, int timeout)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_poll");
  ret = nbd_unlocked_poll (h, timeout);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_aio_connect (struct nbd_handle *h, const struct sockaddr *addr, socklen_t addrlen)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_aio_connect");
  ret = nbd_unlocked_aio_connect (h, addr, addrlen);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_aio_connect_uri (struct nbd_handle *h, const char *uri)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_aio_connect_uri");
  ret = nbd_unlocked_aio_connect_uri (h, uri);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_aio_connect_unix (struct nbd_handle *h, const char *unixsocket)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_aio_connect_unix");
  ret = nbd_unlocked_aio_connect_unix (h, unixsocket);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_aio_connect_tcp (struct nbd_handle *h, const char *hostname, const char *port)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_aio_connect_tcp");
  ret = nbd_unlocked_aio_connect_tcp (h, hostname, port);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_aio_connect_command (struct nbd_handle *h, char **argv)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_aio_connect_command");
  ret = nbd_unlocked_aio_connect_command (h, argv);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int64_t
nbd_aio_pread (struct nbd_handle *h, void *buf, size_t count, uint64_t offset)
{
  int64_t ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_aio_pread");
  ret = nbd_unlocked_aio_pread (h, buf, count, offset);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int64_t
nbd_aio_pwrite (struct nbd_handle *h, const void *buf, size_t count, uint64_t offset, uint32_t flags)
{
  int64_t ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_aio_pwrite");
  ret = nbd_unlocked_aio_pwrite (h, buf, count, offset, flags);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_aio_disconnect (struct nbd_handle *h)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_aio_disconnect");
  ret = nbd_unlocked_aio_disconnect (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int64_t
nbd_aio_flush (struct nbd_handle *h)
{
  int64_t ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_aio_flush");
  ret = nbd_unlocked_aio_flush (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int64_t
nbd_aio_trim (struct nbd_handle *h, uint64_t count, uint64_t offset, uint32_t flags)
{
  int64_t ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_aio_trim");
  ret = nbd_unlocked_aio_trim (h, count, offset, flags);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int64_t
nbd_aio_cache (struct nbd_handle *h, uint64_t count, uint64_t offset)
{
  int64_t ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_aio_cache");
  ret = nbd_unlocked_aio_cache (h, count, offset);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int64_t
nbd_aio_zero (struct nbd_handle *h, uint64_t count, uint64_t offset, uint32_t flags)
{
  int64_t ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_aio_zero");
  ret = nbd_unlocked_aio_zero (h, count, offset, flags);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int64_t
nbd_aio_block_status (struct nbd_handle *h, uint64_t count, uint64_t offset, uint32_t flags, void *data, void (*extent) (void *data, const char *metacontext, uint64_t offset, uint32_t *entries, size_t nr_entries))
{
  int64_t ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_aio_block_status");
  ret = nbd_unlocked_aio_block_status (h, count, offset, flags, data, extent);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_aio_get_fd (struct nbd_handle *h)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_aio_get_fd");
  ret = nbd_unlocked_aio_get_fd (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_aio_get_direction (struct nbd_handle *h)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_aio_get_direction");
  ret = nbd_unlocked_aio_get_direction (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_aio_notify_read (struct nbd_handle *h)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_aio_notify_read");
  ret = nbd_unlocked_aio_notify_read (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_aio_notify_write (struct nbd_handle *h)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_aio_notify_write");
  ret = nbd_unlocked_aio_notify_write (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_aio_is_created (struct nbd_handle *h)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_aio_is_created");
  ret = nbd_unlocked_aio_is_created (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_aio_is_connecting (struct nbd_handle *h)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_aio_is_connecting");
  ret = nbd_unlocked_aio_is_connecting (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_aio_is_ready (struct nbd_handle *h)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_aio_is_ready");
  ret = nbd_unlocked_aio_is_ready (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_aio_is_processing (struct nbd_handle *h)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_aio_is_processing");
  ret = nbd_unlocked_aio_is_processing (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_aio_is_dead (struct nbd_handle *h)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_aio_is_dead");
  ret = nbd_unlocked_aio_is_dead (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_aio_is_closed (struct nbd_handle *h)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_aio_is_closed");
  ret = nbd_unlocked_aio_is_closed (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int
nbd_aio_command_completed (struct nbd_handle *h, int64_t handle)
{
  int ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_aio_command_completed");
  ret = nbd_unlocked_aio_command_completed (h, handle);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

int64_t
nbd_aio_peek_command_completed (struct nbd_handle *h)
{
  int64_t ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_aio_peek_command_completed");
  ret = nbd_unlocked_aio_peek_command_completed (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

const char *
nbd_connection_state (struct nbd_handle *h)
{
  const char *ret;

  pthread_mutex_lock (&h->lock);
  nbd_internal_reset_error ("nbd_connection_state");
  ret = nbd_unlocked_connection_state (h);
  pthread_mutex_unlock (&h->lock);
  return ret;
}

